        Include "P16f818.inc"
;
;********************************************************************** 
        __config        _LVP_OFF & _CP_OFF & _BODEN_ON & _MCLR_OFF & _PWRTE_ON & _WDT_OFF & _EXTCLK & _DEBUG_OFF & _WRT_ENABLE_OFF & _CPD_OFF & _CCP1_RB3
                
			     
;-------------------------------------------
;       Port pin usage        
;-------------------------------------------
                                           
 ; Port A                                       Pin No.
        #define Bat_Detect      PORTA,0         ;17
        ;#define Unused         PORTA,1         ;18
        #define Rs              PORTA,2         ;1
        #define Disp_En         PORTA,3         ;2
        ;#define Unused         PORTA,4         ;3
        ;#define                PORTA,5         ;4
        ;#define                PORTA,6         ;15
        ;#define Osc_In         PORTA,7         ;16

 ; Port B       
        #define R_w             PORTB,0         ;6
        ;#define                PORTB,1         ;7
        #define LCD_Bit6        PORTB,2         ;8
        ;#define PWM_Out        PORTB,3         ;9
        ;#define Disp_4         PORTB,4         ;10
        ;#define Disp_5         PORTB,5         ;11
        ;#define VFO_In         PORTB,6         ;12
        ;#define Disp_7         PORTB,7         ;13

; Ports RB0 - RB3 = pins 6 - 9

        #define rp0             STATUS,RP0
 
;-------------------------------------------
;       Constant Equates Table        
;-------------------------------------------
HoldDelay       equ     .15	        ; Delay after, frequency change - Approx 3 seconds
ADPoleDelay     equ     .12             ; Approx 0.5 seconds
FCountDelay     equ     .1              ; Delay between frequency displays
WelcomeDelay	equ	.10		; Delay whilst welcome text shows
MaxError        equ     .20            	; Max frequency error x 5
MinError	equ	.10		; Error below this value will receive short pulse
TuneError	equ	.5		; Maximum error before hold timer is reset
Pulse		equ	.20		; Correction pulse width - approximatly in uS	
LongPulse	equ	.250		; Long correction pulse		
		
Func_set        equ     b'00101000'
Display_off     equ     b'00001000'
Display_on      equ     b'00001100'     ;cursor off (bit 2)
Clr_display     equ     b'00000001'
Shift_Left	equ	b'00010000'
Entry_inc       equ     b'00000110'
Dd_ram_addr     equ     b'10000000'
Line_One	equ	b'10000000'
Line_Two	equ	b'11000000'

Lcd_init_delay  equ     .255

Portb_Out 	equ	b'01001111' 	;"and" with TRISB register
Portb_In	equ	b'10110000'	;"or" with TRISB register

Lcd_Port	equ     TRISB     
Lcd_Data        equ     PORTB

;-------------------------------------------
;       File Equates Table        
;-------------------------------------------
        cblock 0X20
        FreqLow
        FreqHigh
        FreqUpper
        TMR1U
        ErrorLow
        HoldCounter
        WelcomeCounter
        FCount
        Tmr0PostScale
        Flags
        PWMLow
        PWMHigh
        Temp
        Temp1
        Temp2
        R0		
        R1		
        R2
        R3
        ACC_a_0
        ACC_a_1
        ACC_a_2
	ACC_b_0 		
        ACC_b_1
        ACC_b_2
        ACC_c_0
        ACC_c_1
        ACC_c_2
        ACC_d_0
        ACC_d_1
        ACC_d_2
        Buffer_0	
        Buffer_1	
        Buffer_2	
        Buffer_3	
        Buffer_4	
        Buffer_5	
        Buffer_6	
        Buffer_7	
        Char
        Lsd
        Msd
        Text_pointer
        LoopCount
        LastBar
        ADPoleCount
        LastAD

        endc

;-------------------------------------------
;       File BIT Equates Table        
;-------------------------------------------
        #define ZeroFlag        Flags,0
        #define mult_carry      Flags,1
	#define LockedFlag	Flags,2

;-------------------------------------------
;       Main code        
;-------------------------------------------
ResetVector
        org     0       
        goto    Initialise

;******************************************************************************
;	Text to be output to LCD module
;******************************************************************************
TextTable				;begining of text tables							
	movwf   PCL          		;jump to Char pointed to 
 
Text_Welcome_1
	dt	" MKARS80  V2.4  ",0
Text_Welcome_2
;	dt	" Your call here ",0	; To place your call here edit the text and remove the semi colon
	dt	"www.mkars.org.uk",0	;   place a semi colon in front of this text
Text_MHz
	dt	" Hz",0
Text_LSB
	dt	"LSB ",0
Text_Bat
	dt	"Bat ",0
Text_Free
	dt	"   U   ",0
Text_Empty
	dt	"   +",0	
TextTableEnd
	if HIGH TextTable != HIGH TextTableEnd 
	error "Text Table breaks page boundary"
	endif
	;
;*****************************************************************************
Initialise
        ; Wait a while for the PSU to stabilise
        clrf    PORTA
        clrf    PORTB
        bsf     STATUS,RP0
        movlw   b'11110011'
        movwf   TRISA           	; Set up port A
        movlw   b'01000010'
        movwf   TRISB           	; Set up port B
        movlw   b'10000111'     	; Set up timer 0
        movwf   OPTION_REG      	; Internal clock, prescaler assigned to timer 0
                                	; and prescaler set to 256
        movlw   0XFF            	; Setup timer 2 for PWM
        movwf   PR2
        movlw   b'11001110'     	; Select A/D convertor input as RA0, A/D clock/2 and result right justified
        movwf   ADCON1
        bcf     STATUS,RP0
        movlw   b'00000111'
        movwf   T1CON           	; Set up timer 1 
        movlw   b'00000100'
        movwf   T2CON
        call    InitialisePWM
        movlw   .30            		; FCountDelay     ; Set Freq counter delay period
        movwf   FCount
        movlw   .255
        movwf   LastBar         	; Preset LastBar to generate bar display
        movlw   ADPoleDelay
        movwf   ADPoleCount     	; Preset AD convertor delay counter
        ; Initialise A/D convertor module
        movlw   b'01000001'     	; Channel 0, A/D convertor running
        movwf   ADCON0	
        ; initialise display
        call    lcd_delay               ; Allow plenty of time for LCD to initialise
	call	Lcd_init		; Initialise LCD display
	;call 	write_cg_ram		; Write bar to CG ram
	movlw	Display_on		; Turn display on
	call	send_cmd
	movlw	WelcomeDelay
	movwf	WelcomeCounter		; Load delay counter
        call    Welcome_Routine
        ; Make 1st A/D conversion
        bsf     ADCON0,2
        movlw   .255      		; Load 40ms counter
        movwf   Tmr0PostScale
	goto 	Loop

;*****************************************************************************
InitialisePWM
	bsf	STATUS,RP0
	bcf	PORTB,3		; Enable PWM pin as output
	bcf	STATUS,RP0
        movlw   b'00001100'
        movwf   CCP1CON         ; Turn on PWM with xxxx11xx, lower PWM bits in 5-4
        clrf    PWMLow          ; Reset software PWM counter
        movlw   b'00000010'
        movwf   PWMHigh
        call    LoadPWM
        movlw   HoldDelay    	; Set start up delay 
        movwf   HoldCounter
        return

;******************************************************************************
Welcome_Routine
	movlw	Clr_display
	call	send_cmd
	movlw   b'10000000'			; Sets ram address at 00h i.E. the start
	call    send_cmd
	movlw	Text_Welcome_1 - TextTable	; Point to message
	call	LCD_Out
	movlw   Line_Two			; First digit line 2
	call    send_cmd
	movlw	Text_Welcome_2 - TextTable	; Point to message
	call	LCD_Out
	return

;*****************************************************************************
;Loop    
;*****************************************************************************
Loop    
        clrf    TMR1L          
        clrf    TMR1H           
        clrf    TMR1U           	; Reload TMR1L, TIMR1H and pseudo timer TMR1U with 0
        bcf     PIR1,TMR1IF
        bsf     T1CON,TMR1ON    	; Enable counter(timer 1) 
        movlw   .255
        movwf   Temp
CounterDelayLoop
        btfsc   PIR1,TMR1IF     	; Check for timer 1 interupt
        goto    IncrementTMR1U
        nop				; Cycles to add delay to compensate TMR1U incrementation
        nop
        nop
        nop
        nop
CounterDelay1
        movlw   .216
        movwf   LoopCount
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
        decfsz  LoopCount,f
        goto    $-7             ; Loop until complete
        decfsz  Temp,f
        goto    CounterDelayLoop
	;
	movlw	.64
	movwf	Temp
	decfsz Temp,f
	goto	$-1
	nop
	nop
	nop
	nop
	;
        bcf     T1CON,TMR1ON    ; Stop timer 1
        btfsc   PIR1,TMR1IF     ; Check for timer 1 interupt flag
        incf    TMR1U,f
	;
	movf	WelcomeCounter,f	
	btfsc	STATUS,Z
	goto	Loop1
	decfsz	WelcomeCounter,f
	goto	WaitingTimeout
	; Initialise display	
	movlw	Clr_display	
	bcf	ZeroFlag
	bcf	LockedFlag
	call	send_cmd
	call	DisplayFreq
	call	BatVolts
	call	TuningBar
Loop1
        movf    HoldCounter,f   ; Is Start delay = 0?
        btfsc   STATUS,Z
        goto    DelayFinished   ; Yes, then continue
        decfsz  HoldCounter,f
        goto    WaitingTimeout  ; No, display frequency
        movfw   TMR1L           ; Save frequency count
        movwf   FreqLow
        movfw   TMR1H
        movwf   FreqHigh
        movfw   TMR1U
        movwf   FreqUpper
        call    DisplayFreq
        goto    ReloadTimer1    ; All setup so finish
WaitingTimeout
        decfsz  FCount,f
        goto    ReloadTimer1
        movlw   FCountDelay     ; Set Freq counter delay period
        movwf   FCount
        call    DisplayFreq
	goto	CalculateError
;        goto    ReloadTimer1    ; No other action, exit
DelayFinished
	clrf	CCP1CON		; disable PWM generator
	bsf	STATUS,RP0
	bsf	PORTB,3		; Set PWM pin to high Z
	bcf	STATUS,RP0
CalculateError
        bsf     ZeroFlag
        movfw   TMR1L           ; Subtract to find error and save difference
        subwf   FreqLow,w
        movwf   ErrorLow
        btfss   STATUS,Z        ; Record value of zero bit
        bcf     ZeroFlag
        movfw   TMR1H           ; Subtract to find error and save difference
        btfss   STATUS,C
        addlw   .1              ; Add carry
        subwf   FreqHigh,w
        btfss   STATUS,Z        ; Record value of zero bit
        bcf     ZeroFlag
        movfw   TMR1U           ; Subtract to find error and save difference
        btfss   STATUS,C
        addlw   .1              ; Add carry
        subwf   FreqUpper,w
        btfss   STATUS,Z        ; Record value of zero bit
        bcf     ZeroFlag
        btfss   STATUS,C
        goto    FrequencyHigh   ; No carry so frequency is high
        btfsc   ZeroFlag        ; Test for ON frequency
        goto    ReloadTimer1    ; On frequency so no PWM adjustment needed
FrequencyLow
        movf    HoldCounter,f   ; Is Start delay = 0?
        btfss   STATUS,Z
        goto    TuneModeLow   ; No
        movlw   MaxError        ; Test for error > max error
        subwf   ErrorLow,w
        btfsc   STATUS,C
        goto    ResetPWM        ; Error greater than allowed so reset PWM
        movlw   MinError        ; Test for error > min error
        subwf   ErrorLow,w
	movlw	Pulse		; Correction pulse width
        btfsc   STATUS,C
	movlw	LongPulse	; Correction pulse width
	movwf	Temp
	;
	; Send high pulse
	bsf	PORTB,3		; Set for +ve pulse
	call	PulseOut
	;
ReloadTimer1
	movf	WelcomeCounter,f
	btfss	STATUS,Z	; Continue if welcome message still displayed
        goto    ReloadTimer1_2
        decfsz  ADPoleCount,f
        goto    ReloadTimer1_1
        movlw   ADPoleDelay
        movwf   ADPoleCount     ; Reload delay counter
        call	BatVolts
        ; Start next A/D conversion
        bsf     ADCON0,2
ReloadTimer1_1
        call    TuningBar
ReloadTimer1_2        
	bsf     T1CON,TMR1ON    ; Enable counter(timer 1) 
        goto    Loop

FrequencyHigh
        movf    HoldCounter,f   ; Is Start delay = 0?
        btfss   STATUS,Z
        goto    TuneModeHigh   ; No
	movlw   MaxError+.1     ; Test for error > max error
        addwf   ErrorLow,w
        btfss   STATUS,C
        goto    ResetPWM        ; Error greater than allowed so reset PWM
	movlw   MinError+.1     ; Test for error > min error
        addwf   ErrorLow,w
	movlw	Pulse		; Correction pulse width
        btfss   STATUS,C
	movlw	LongPulse	; Long correction pulse width
	movwf	Temp
	;
	; Send low pulse
	bcf	PORTB,3		; Set for +ve pulse
	call	PulseOut
       	goto    ReloadTimer1    
	;
TuneModeLow
        movlw   TuneError       ; Test for error > tune error
        subwf   ErrorLow,w
        btfss   STATUS,C
       	goto    ReloadTimer1    
	goto	ResetPWM	; Error greater than allowed
	;
TuneModeHigh
	movlw   TuneError+.1    ; Test for error > max TuneError
        addwf   ErrorLow,w
        btfsc   STATUS,C
       	goto    ReloadTimer1    
	goto	ResetPWM	; Error greater than allowed
	;
;*****************************************************************************
PulseOut
	bsf	LockedFlag	; Fequency is within lock range
	bsf	STATUS,RP0	; Set tuning pin to output
	bcf	TRISB,3
	bcf	STATUS,RP0
	decfsz	Temp,f		; Temp assigned pulse width in calling routine
	goto	$-1
	bsf	STATUS,RP0	; Set tuning pin to high Z
	bsf	TRISB,3
	bcf	STATUS,RP0
	return
	;
;*****************************************************************************
LoadPWM
        movfw   PWMHigh         ; Save PWM files to temporary registers
        movwf   Temp1
        movfw   PWMLow
        movwf   Temp2
        rrf     Temp1,f         ; Rotate high byte in to low and set
        rrf     Temp2,f         ;  CCP1CON bits with "overflow"
        bcf     CCP1CON,4
        btfsc   STATUS,C
        bsf     CCP1CON,4
        rrf     Temp1,f
        rrf     Temp2,w
        bcf     CCP1CON,5
        btfsc   STATUS,C
        bsf     CCP1CON,5
        movwf   CCPR1L          ; Save shifted high byte in PWM register
        return
	;
;*****************************************************************************
ResetPWM
        call    InitialisePWM
	bcf	LockedFlag	; Indicate no lock
        movfw   TMR1L           ; Save frequency
        movwf   FreqLow
        movfw   TMR1H
        movwf   FreqHigh
        movfw   TMR1U
        movwf   FreqUpper
        goto    ReloadTimer1
	;
;*****************************************************************************
IncrementTMR1U
        incf    TMR1U,f                 ; Increment upper byte of frequency count
        bcf     PIR1,TMR1IF
        goto    CounterDelay1
	;
;*****************************************************************************
LCD_Out 
LCD_Out_loop
	movwf	Text_pointer
	movwf   Temp1           	;Temp1 holds start of message 
	movlw	LOW TextTable	        ;address
	addwf	Temp1,f		        ;add offset
	movlw	HIGH TextTable	
	btfsc	STATUS,C		;check if over page boundary
	addlw	1			;yes so inc high byte
	movwf	PCLATH
	movfw	Temp1
	call	TextTable
	andlw   0ffh   			;check if at end of message (zero
	btfsc   STATUS,Z	  	;returned at end)
	goto    LCD_Out_end         
	call    send_char		;display character
	movfw   Text_pointer		;point to next character
	addlw   1
	goto    LCD_Out_loop
LCD_Out_end
	return

;*****************************************************************************
DisplayFreq
	;	Set to line one, first character in
	movlw	b'10000000'
	call	send_cmd
	;
	movlw	Text_LSB - TextTable	        ; Point to message
	call	LCD_Out
        ;
        movlw   h'80'
	movwf	ACC_b_0
        movlw   h'84'
	movwf	ACC_b_1
        movlw   h'1E'
	movwf	ACC_b_2		  
	movfw	TMR1L
	movwf	ACC_a_0
        movfw   TMR1H
	movwf	ACC_a_1
        movfw   TMR1U
	movwf	ACC_a_2 
	call	Subtract_24	; Subtract Acc_a for Acc_b, result in Acc_b
	;
        call    Mult5
        call	B2_BCD	
	call	Expand_BCD
	;
	movfw	Buffer_0
	call	send_char	; 1MHz
	movlw	"."	
	call	send_char	; Display "."
	movfw	Buffer_1
	call	send_char	; 100kHz
	movfw	Buffer_2
	call	send_char	; 10kHz
	movfw	Buffer_3
	call	send_char	; 1KHz
	movlw	"."	
	call	send_char	; Display "."
	movfw	Buffer_4
	call	send_char	; 100Hz
	movfw	Buffer_5
	call	send_char	; 10Hz
	movfw	Buffer_6
	call	send_char	; 1Hz
	;
	movlw	Text_MHz - TextTable
	call	LCD_Out
	return

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
BatVolts
        ; Read A/D convertor result 
        ; Load 9 bits od A/D result and multiply by 3662
        bcf     STATUS,C        
        rrf     ADRESH,w        ; Only 9 bits used
        movwf   ACC_a_1
        bsf     STATUS,RP0      ; Lose LSB
        rrf     ADRESL,w
        bcf     STATUS,RP0
        movwf   ACC_a_0
        subwf   LastAD,w        ; Check to see if same value as last time
        btfsc   STATUS,Z
        goto    BatVoltsEnd     ; If same abandon display
        movfw   ACC_a_0
        movwf   LastAD
        movlw   .78
	movwf	ACC_b_0
        movlw   .14
        movwf   ACC_b_1
        ;
        call    D_mpy 
        ; Convert high to BCD
        movfw   ACC_b_0         ; High byte
        movwf   ACC_b_2
        movfw   ACC_c_0
        movwf   ACC_b_0
        movfw   ACC_c_1
        movwf   ACC_b_1
        call	B2_BCD	
	call	Expand_BCD
	;
        ; Display in row 2 digits 0 to 2
	; Set to line one, first character in
	movlw	b'11000000'
	call	send_cmd
	;
	movlw	Text_Bat - TextTable	        ; Point to message
	call	LCD_Out
        ;
	movfw	Buffer_0
	call	send_char	
	movfw	Buffer_1
	call	send_char	
	movlw	"."	
	call	send_char	; Display "."
	movfw	Buffer_2
	call	send_char	
	movlw	"V"	
	call	send_char	; Display "V"
BatVoltsEnd
	return
	;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
TuningBar
	movlw	b'11001001'     ; Start at 9th character position on line two
	call	send_cmd
	;
	btfss	LockedFlag	; If unlocked display "U"
	goto	Tb1		
	;
	movfw	ErrorLow	; If same error as last time don't re-display
        subwf   LastBar,w
        btfsc   STATUS,Z        ; Same as last bar position?
        goto    TuningBarEnd    ; Z bit set so is the same
	;
	btfsc	ErrorLow,7	; Check for negative error
	goto 	NegativeBar
	movlw	.15		; Error > 75Hz?
	subwf	ErrorLow,w
	movlw	" "
	btfsc	STATUS,C	
	movlw	"-"		; Yes, bar
        call    send_char
	movlw	.10		; Error > 50Hz?
	subwf	ErrorLow,w
	movlw	" "
	btfsc	STATUS,C	
	movlw	"-"		; Yes, bar
        call    send_char
	movlw	.5		; Error > 25Hz?
	subwf	ErrorLow,w
	movlw	" "
	btfsc	STATUS,C	
	movlw	"-"		; Yes, bar
        call    send_char
	movlw	"+"		; Centre - bar
        call    send_char
	movlw	Text_Empty - TextTable
	call 	LCD_Out
	goto	TuningBarEnd
NegativeBar
	movlw	Text_Empty - TextTable
	call 	LCD_Out
	movlw	.255 - .5	; Error > 256 - 25Hz?
	subwf	ErrorLow,w
	movlw	"-"
	btfsc	STATUS,C	
	movlw	" "		; Yes, bar
        call    send_char
	movlw	.255 - .10	; Error > 256 - 50Hz?
	subwf	ErrorLow,w
	movlw	"-"
	btfsc	STATUS,C	
	movlw	" "		; Yes, bar
        call    send_char
	movlw	.255 - .15	; Error > 256 - 75Hz?
	subwf	ErrorLow,w
	movlw	"-"
	btfsc	STATUS,C	
	movlw	" "		; Yes, bar
        call    send_char
TuningBarEnd
        return
	;
Tb1
	movlw	Text_Free - TextTable	; Point to message
	call	LCD_Out
	goto	TuningBarEnd
	;
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;		Modified from AN526
;********************************************************************
;                  Binary To BCD Conversion Routine
;      This routine converts a 24 Bit binary Number to a 7 Digit
; BCD Number. 
;       The 24 bit binary number is input in locations ACC_b_2,ACC_b_1 and
; ACC_b_0 with the high byte in ACC_b_2.
;       The 7 digit BCD number is returned in R0, R1, R2 and R3 with R0
; containing the MSD in its right most nibble.
;
;
;       Program:          B16TOBCD.ASM 
;
;*******************************************************************;
;
B2_BCD  bcf     STATUS,0 	; clear the carry bit
	movlw   .24
	movwf   Temp2
	clrf    R0
	clrf    R1
	clrf    R2
	clrf	R3
loop24  
	rlf     ACC_b_0, F
	rlf     ACC_b_1, F
	rlf     ACC_b_2, F
	rlf     R3, F
	rlf     R2, F
	rlf     R1, F
	rlf     R0, F
;
	decfsz  Temp2, F
	goto    adjDEC
	RETLW   0
;
adjDEC  
	movlw   R3
	movwf   FSR
	call    adjBCD
;
	movlw   R2
	movwf   FSR
	call    adjBCD
;
	movlw   R1
	movwf   FSR
	call    adjBCD
;
	movlw   R0
	movwf   FSR
	call    adjBCD
;
	goto    loop24
;
adjBCD  movlw   3
	addwf   0,W
	movwf   Temp1
	btfsc   Temp1,3	; test if result > 7
	movwf   0
	movlw   30
	addwf   0,W
	movwf   Temp1
	btfsc   Temp1,7 	; test if result > 7
	movwf   0              	; save as MSD
	retlw   0

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
Expand_BCD
	movfw	R0
	addlw	h'30'		; Add ascii offset
	movwf	Buffer_0
;
	swapf	R1,w
	andlw	h'0f'		; Mask off lower nibble
	addlw	h'30'
	movwf	Buffer_1
;
	movfw	R1
	andlw	h'0f'		; Mask off lower nibble	
	addlw	h'30'
	movwf	Buffer_2
;
	swapf	R2,w
	andlw	h'0f'		; Mask off lower nibble
	addlw	h'30'
	movwf	Buffer_3
;
	movfw	R2
	andlw	h'0f'		; Mask off lower nibble	
	addlw	h'30'
	movwf	Buffer_4
;
	swapf	R3,w
	andlw	h'0f'		; Mask off lower nibble
	addlw	h'30'
	movwf	Buffer_5
;
	movfw	R3
	andlw	h'0f'		; Mask off lower nibble	
	addlw	h'30'
	movwf	Buffer_6
	return

;*******************************************************************;
Mult5
        ; Shift left 2 times = x4
        bcf     STATUS,C
        rlf     ACC_b_0,w
        movwf   ACC_c_0
        rlf     ACC_b_1,w
        movwf   ACC_c_1
        rlf     ACC_b_2,w
        movwf   ACC_c_2         ; x2
        rlf     ACC_c_0,f
        rlf     ACC_c_1,f
        rlf     ACC_c_2,f       ; x4 shifetd is in Acc_c original in Acc_b
        ; Add to original = x 5
        movfw   ACC_c_0
        addwf   ACC_b_0,f
        movfw   ACC_c_1
        btfsc   STATUS,C
        incfsz  ACC_c_1,w
        addwf   ACC_b_1,f
        movfw   ACC_c_2
        btfsc   STATUS,C
        incfsz  ACC_c_2,w
        addwf   ACC_b_2,f
        return

;*******************************************************************;
Subtract_24
	movfw	ACC_a_0
	subwf	ACC_b_0,f
	btfsc	STATUS,C	; Carry set?
	goto	Sub1		; Yes
	movlw	.1		; No
	addwf	ACC_a_1,f
	btfsc	STATUS,C
	addwf	ACC_a_2,f	; Ripple carry through
Sub1
	movfw	ACC_a_1
	subwf	ACC_b_1,f
	btfsc	STATUS,C	; Carry set?
	goto	Sub2		; Yes
	movlw	.1		; No
	addwf	ACC_a_2,f
Sub2	
	movfw	ACC_a_2
	subwf	ACC_b_2,f
	return

;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
;		Modified from AN526
;*******************************************************************
;                    Double Precision Multiplication
;
;               ( Optimized for Code Size : Looped Code )
;
;*******************************************************************;
;   Multiplication : ACCb(16 bits) * ACCa(16 bits) -> ACCb,ACCc ( 32 bits )
;      (a) Load the 1st operand in location ACC_a_0 & ACC_a_1 ( 16 bits )
;      (b) Load the 2nd operand in location ACC_b_0 & ACC_b_1 ( 16 bits )
;      (c) CALL D_mpy
;      (d) The 32 bit result is in location ( ACC_b_1,ACC_b_0,ACC_c_1,ACC_c_0 )
;
;   Performance :
;               Program Memory  :       033
;               Clock Cycles    :       333
;
;       Note : The above timing is the worst case timing, when the
;               register ACCb = FFFF. The speed may be improved if
;               the register ACCb contains a number ( out of the two
;               numbers ) with less number of 1s.
;               The performance specs are for Unsigned arithmetic ( i.e,
;               with "SIGNED equ  FALSE ").
;
;               The performance specs are for Unsigned arithmetic ( i.e,
;               with "SIGNED equ  FALSE ").
;
;
;       Program:          DBL_MPYS.ASM 
;       Revision Date:   
;                         12-12-95      Compatibility with MPASMWIN 1.30
;
;*******************************************************************;
;         Double Precision Addition ( ACCb + ACCa -> ACCb )
;
D_add   bcf	mult_carry	;Clear Temp_1 Carry bit
	movf    ACC_a_0,w        ; Addition ( ACCb + ACCa -> ACCb )
	addwf   ACC_b_0, F       ;add lsb
	movlw	.1
	btfsc   STATUS,C		;add in carry
 	addwf	ACC_b_1, F
	btfsc	STATUS,C
	bsf	mult_carry	
	movf    ACC_a_1,w
	addwf   ACC_b_1, F         ;add msb
	btfsc	mult_carry
	bsf	STATUS,C
	retlw   0
;*******************************************************************
;               Double Precision Multiply ( 16x16 -> 32 )
;         ( ACCb*ACCa -> ACCb,ACCc ) : 32 bit output with high word
;  in ACCb ( ACC_b_1,ACC_b_0 ) and low word in ACCc ( ACC_c_1,ACC_c_0 ).
;
D_mpy                           ;results in ACCb(16 msb's) and ACCc(16 lsb's)
;
	call    setup
mloop   rrf     ACC_d_1, F       ;rotate d right
	rrf     ACC_d_0, F
	btfsc   STATUS,C    	;need to add?
	call    D_add
	rrf     ACC_b_1, F
	rrf     ACC_b_0, F
	rrf     ACC_c_1, F
	rrf     ACC_c_0, F
	decfsz  Temp1, F        ;loop until all bits checked
	goto    mloop
;
	retlw   0
;*******************************************************************
;
setup   movlw   .16             ; for 16 shifts
	movwf   Temp1
	movf    ACC_b_1,w          ;move ACCb to ACCd
	movwf   ACC_d_1
	movf    ACC_b_0,w
	movwf   ACC_d_0
	clrf    ACC_b_1
	clrf    ACC_b_0
	retlw   0
;
;*******************************************************************
;
neg_A   comf    ACC_a_0, F       ; negate ACCa ( -ACCa -> ACCa )
	incf    ACC_a_0, F
	btfsc   STATUS,Z
	decf    ACC_a_1, F
	comf    ACC_a_1, F
	retlw   0
;
        include "lcd_4bit.inc"

	END


